## Summary

* [Introduction](README.MD)

## Semantic-Data Processing

* [Domain Model](SemanticDataSolution/README.MD)
* [Library Description](SemanticDataSolution/Readme.SemanticDataDeplyment.MD)
* [OPC UA NodeSet Validation](SemanticDataSolution/UANodeSetValidation/README.MD)
* [XML Files](SemanticDataSolution/UANodeSetValidation/XML/README.MD)

## Internet of Things (IOT) Archetype

### Communication

* [Internet of Things (IOT) Communication](Networking/README.MD)
* [UA Semantic Data Message Centric Communication](SemanticDataSolution/README.MessageCentricCommunication.md)
* [Networking of SemanticData Library](Networking/SemanticData/README.MD)
* [OPC Unified Architecture Part 14: PubSub Main Technology Features](Networking/SemanticData/README.PubSubMTF.md)
* [Underlying Transport over UDP](Networking/UDPMessageHandler/README.md)
* [Underlying Transport over MQTT](Networking/SemanticData/README_MQTTMapping.md)
* [Underlying Transport over AMQP](Networking/SemanticData/README_AMQPMapping.md)
* [Data management and binding](Networking/SemanticData/READMEDataDiscoveryAndBinding.md)

### Configuration

* [Reactive Networking Configuration](Configuration/Networking/README.MD)
* [DataBinding library](Configuration/DataBindings/README.MD)

### Deployment 

* [Getting Started Tutorial](Networking/SemanticData/READMEGettingStartedTutorial.md)
* [Reference Application](Networking/ReferenceApplication/README.MD)

## Data Discovery

* [Global Data Discovery](DataDiscovery/README.MD)
* [Domain Model of the Global Data Discovery](DataDiscovery/DomainModel.md)

## References

* [See also](REFERENCES.md)
